#include<stdio.h>

// Calcolo della somma dei primi N numeri pari

int somma_pari(int N)
{
    if (N==0)
        {return 0; }
    else
        return 2*(N-1)+somma_pari(N-1);
}

//La funzione scritta non è tail ricorsiva, infatti dopo la chiamata ricorsiva deve ancora essere effettuata la somma. Il compilatore non potrebbe quindi 
//effettuare l'ottimizzazione tail, cioè riutilizzare il record di attivazione di una chiamata per eseguirne un'altra.
//Per avere una versione tail ricorsiva è necessario inserire un nuovo parametro che rappresenta la somma calcolata fino a quel momento.

int somma_pari_tail(int N, int S)
{
    if (N==0)
        {return S; }
    else
        return somma_pari_tail(N-1,S+2*(N-1));
} 
main(){
  int n, somma;
  printf("Inserisci il valore: ");
  
  scanf("%d",&n);
  
  somma = somma_pari(n, 0);
  somma = somma_pari_tail(n, 0);
  
  printf("La somma dei primi n numeri pari e': %d \n", somma);
}
